%punti di interpolazione
x=-55:10:65;
y=[3.7 3.7 3.52 3.27 3.2 3.15 3.15 3.25 3.47 3.52 3.65 3.67 3.52];

% punti di valutazione per gli approssimanti/interpolanti
xx=linspace(min(x),max(x),200);

%1. Approssimazione mediante minimi quadrati con un polinomio di grado 1
a1=polyfit(x,y,1);
%Valutazione dell'approssimante di grado 1
yy1=polyval(a1,xx);
%2. Approssimazione mediante minimi quadrati con un polinomio di grado 2
a2=polyfit(x,y,2);
yy2=polyval(a2,xx);

% Equivalenti alla seguente:
% approssimazione ai minimi quadrati grado 1
%H=[ones(length(x),1) x'];
%a=H\y';
%yyy=polyval([a(2),a(1)],z);
%plot(z,yyy,'m');

% approssimazione ai minimi quadrati grado 2
%H=[ones(length(x),1) x' (x.^2)'];
%a=H\y';
%yyy=polyval([a(3),a(2),a(1)],z);
%plot(z,yyy,'k');

%-----------------------------------------------------------------------
%3. Interpolazione con un polinomio di grado 12(=numero di punti - 1)
c=InterpN(x,y);
%Valutazione dell'interpolante di Newton
yy3=HornerN(c,x,xx);
%-----------------------------------------------------------------------
%4. Interpolazione con spline cubiche
yy4=spline(x,y,xx);

%Valutazioni della temperatura per xx=42
yv1=polyval(a1,42);
yv2=polyval(a2,42);
yv3=HornerN(c,x,42);
yv4=spline(x,y,42);

fprintf('Utilizzando i 4 metodi, le stime della temperatura a latitudine 42 risultano:\n');
disp([yv1 yv2 yv3 yv4]);

% Disegna il grafico degli approssimanti/interpolanti
plot(xx,yy1,'b-',xx,yy2,'g-',xx,yy3,'m-',xx,yy4,'y-',x,y,'r*',42,yv1,'bo',42,yv2,'go',42,yv3,'mo',42,yv4,'yo');
legend('1.Approssimante lineare','2.Approssimante quadratico','3.Interpolante di Newton','4.Interpolante spline cubica','Dati',...
       'T1','T2','T3','T4');
